# trober_sdk.api.DefaultApi

## Load the API package
```dart
import 'package:trober_sdk/api.dart';
```

All URIs are relative to *https://trober-test.herokuapp.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**appinfoGet**](DefaultApi.md#appinfoget) | **GET** /appinfo | Get supported App info
[**carriersGet**](DefaultApi.md#carriersget) | **GET** /carriers | List all Carriers
[**carriersIdGet**](DefaultApi.md#carriersidget) | **GET** /carriers/{id} | Get carrier details
[**carriersIdPut**](DefaultApi.md#carriersidput) | **PUT** /carriers/{id} | Update an existing carrier
[**carriersPost**](DefaultApi.md#carrierspost) | **POST** /carriers | Create a new Carrier
[**customersGet**](DefaultApi.md#customersget) | **GET** /customers | List all Customers
[**customersIdGet**](DefaultApi.md#customersidget) | **GET** /customers/{id} | Get customer details
[**customersIdPut**](DefaultApi.md#customersidput) | **PUT** /customers/{id} | Update an existing customer
[**customersPost**](DefaultApi.md#customerspost) | **POST** /customers | Create a new Customer
[**healthGet**](DefaultApi.md#healthget) | **GET** /health | Get server health
[**ordersGet**](DefaultApi.md#ordersget) | **GET** /orders | List all Orders
[**ordersIdGet**](DefaultApi.md#ordersidget) | **GET** /orders/{id} | Get order details
[**ordersIdPut**](DefaultApi.md#ordersidput) | **PUT** /orders/{id} | Update an existing order
[**ordersPost**](DefaultApi.md#orderspost) | **POST** /orders | Create a new Order
[**selfDeviceRegisterPost**](DefaultApi.md#selfdeviceregisterpost) | **POST** /self/device-register | Register the device for the user
[**selfDeviceRemovePost**](DefaultApi.md#selfdeviceremovepost) | **POST** /self/device-remove | Remove the device for the user
[**selfGet**](DefaultApi.md#selfget) | **GET** /self | Get details of the logged in user
[**selfTenantGet**](DefaultApi.md#selftenantget) | **GET** /self/tenant | Get tenant details of the logged in user
[**shipmentsGet**](DefaultApi.md#shipmentsget) | **GET** /shipments | List all Shipments
[**shipmentsIdGet**](DefaultApi.md#shipmentsidget) | **GET** /shipments/{id} | Get shipment details
[**shipmentsIdPut**](DefaultApi.md#shipmentsidput) | **PUT** /shipments/{id} | Update an existing shipment
[**shipmentsPost**](DefaultApi.md#shipmentspost) | **POST** /shipments | Create a new Shipment
[**tenantsGet**](DefaultApi.md#tenantsget) | **GET** /tenants | List all tenants
[**tenantsIdGet**](DefaultApi.md#tenantsidget) | **GET** /tenants/{id} | Get tenant details
[**tenantsIdPut**](DefaultApi.md#tenantsidput) | **PUT** /tenants/{id} | Update an existing tenant
[**tenantsPost**](DefaultApi.md#tenantspost) | **POST** /tenants | Create a new tenant
[**terminalsGet**](DefaultApi.md#terminalsget) | **GET** /terminals | List all Terminals
[**terminalsIdGet**](DefaultApi.md#terminalsidget) | **GET** /terminals/{id} | Get terminal details
[**terminalsIdPut**](DefaultApi.md#terminalsidput) | **PUT** /terminals/{id} | Update an existing terminal
[**terminalsPost**](DefaultApi.md#terminalspost) | **POST** /terminals | Create a new Terminal
[**usersGet**](DefaultApi.md#usersget) | **GET** /users | List all users
[**usersIdDelete**](DefaultApi.md#usersiddelete) | **DELETE** /users/{id} | Delete the user
[**usersIdGet**](DefaultApi.md#usersidget) | **GET** /users/{id} | Get user details
[**usersIdPut**](DefaultApi.md#usersidput) | **PUT** /users/{id} | Update an existing user
[**usersPost**](DefaultApi.md#userspost) | **POST** /users | Create a new user


# **appinfoGet**
> AppInfo appinfoGet()

Get supported App info

Get supported App info

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();

try {
    final response = api.appinfoGet();
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->appinfoGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**AppInfo**](AppInfo.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersGet**
> BuiltList<Carrier> carriersGet(tenantId, name, page, type)

List all Carriers

List all Carriers

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final String name = name_example; // String | The name of the carrier. Matches names that begin with the values
final int page = page_example; // int | The page number
final CarrierType type = ; // CarrierType | The type of the carrier.

try {
    final response = api.carriersGet(tenantId, name, page, type);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->carriersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| The id of the tenant | [optional] 
 **name** | **String**| The name of the carrier. Matches names that begin with the values | [optional] 
 **page** | **int**| The page number | [optional] 
 **type** | [**CarrierType**](.md)| The type of the carrier. | [optional] 

### Return type

[**BuiltList&lt;Carrier&gt;**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersIdGet**
> Carrier carriersIdGet(id, tenantId)

Get carrier details

Get carrier details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the carrier
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.carriersIdGet(id, tenantId);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->carriersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the carrier | 
 **tenantId** | **String**| The id of the tenant | [optional] 

### Return type

[**Carrier**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersIdPut**
> Carrier carriersIdPut(id, carrier)

Update an existing carrier

Update an existing carrier

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the carrier
final Carrier carrier = ; // Carrier | 

try {
    final response = api.carriersIdPut(id, carrier);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->carriersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the carrier | 
 **carrier** | [**Carrier**](Carrier.md)|  | [optional] 

### Return type

[**Carrier**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersPost**
> Carrier carriersPost(carrier)

Create a new Carrier

Create a new Carrier

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final Carrier carrier = ; // Carrier | 

try {
    final response = api.carriersPost(carrier);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->carriersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **carrier** | [**Carrier**](Carrier.md)|  | [optional] 

### Return type

[**Carrier**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersGet**
> BuiltList<Customer> customersGet(tenantId, name, page)

List all Customers

List all Customers

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final String name = name_example; // String | The name of the customer. Matches names that begin with the values
final int page = page_example; // int | The page number

try {
    final response = api.customersGet(tenantId, name, page);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->customersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| The id of the tenant | [optional] 
 **name** | **String**| The name of the customer. Matches names that begin with the values | [optional] 
 **page** | **int**| The page number | [optional] 

### Return type

[**BuiltList&lt;Customer&gt;**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersIdGet**
> Customer customersIdGet(id, tenantId)

Get customer details

Get customer details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the customer
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.customersIdGet(id, tenantId);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->customersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the customer | 
 **tenantId** | **String**| The id of the tenant | [optional] 

### Return type

[**Customer**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersIdPut**
> Customer customersIdPut(id, customer)

Update an existing customer

Update an existing customer

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the customer
final Customer customer = ; // Customer | 

try {
    final response = api.customersIdPut(id, customer);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->customersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the customer | 
 **customer** | [**Customer**](Customer.md)|  | [optional] 

### Return type

[**Customer**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersPost**
> Customer customersPost(customer)

Create a new Customer

Create a new Customer

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final Customer customer = ; // Customer | 

try {
    final response = api.customersPost(customer);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->customersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customer** | [**Customer**](Customer.md)|  | [optional] 

### Return type

[**Customer**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **healthGet**
> healthGet()

Get server health

Get server health status

### Example
```dart
import 'package:trober_sdk/api.dart';

final api = TroberSdk().getDefaultApi();

try {
    api.healthGet();
} catch on DioError (e) {
    print('Exception when calling DefaultApi->healthGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersGet**
> BuiltList<Order> ordersGet(tenantId, page, customerId, serialNumber, status)

List all Orders

List all Orders

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final int page = page_example; // int | The page number
final String customerId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the customer
final String serialNumber = serialNumber_example; // String | The serialNumber of the order. Matches serialNumber that begin with the values
final OrderStatus status = ; // OrderStatus | The status of the order.

try {
    final response = api.ordersGet(tenantId, page, customerId, serialNumber, status);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->ordersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| The id of the tenant | [optional] 
 **page** | **int**| The page number | [optional] 
 **customerId** | **String**| The id of the customer | [optional] 
 **serialNumber** | **String**| The serialNumber of the order. Matches serialNumber that begin with the values | [optional] 
 **status** | [**OrderStatus**](.md)| The status of the order. | [optional] 

### Return type

[**BuiltList&lt;Order&gt;**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersIdGet**
> Order ordersIdGet(id, tenantId)

Get order details

Get order details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the order
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.ordersIdGet(id, tenantId);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->ordersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the order | 
 **tenantId** | **String**| The id of the tenant | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersIdPut**
> Order ordersIdPut(id, order)

Update an existing order

Update an existing order

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the order
final Order order = ; // Order | 

try {
    final response = api.ordersIdPut(id, order);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->ordersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the order | 
 **order** | [**Order**](Order.md)|  | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersPost**
> Order ordersPost(order)

Create a new Order

Create a new Order

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final Order order = ; // Order | 

try {
    final response = api.ordersPost(order);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->ordersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **order** | [**Order**](Order.md)|  | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfDeviceRegisterPost**
> selfDeviceRegisterPost(deviceId)

Register the device for the user

Register the device for the user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final DeviceId deviceId = ; // DeviceId | 

try {
    api.selfDeviceRegisterPost(deviceId);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->selfDeviceRegisterPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceId** | [**DeviceId**](DeviceId.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfDeviceRemovePost**
> selfDeviceRemovePost(deviceId)

Remove the device for the user

Remove the device for the user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final DeviceId deviceId = ; // DeviceId | 

try {
    api.selfDeviceRemovePost(deviceId);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->selfDeviceRemovePost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceId** | [**DeviceId**](DeviceId.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfGet**
> User selfGet()

Get details of the logged in user

Get details of the logged in user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();

try {
    final response = api.selfGet();
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->selfGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfTenantGet**
> Tenant selfTenantGet()

Get tenant details of the logged in user

Get tenant details of the logged in user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();

try {
    final response = api.selfTenantGet();
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->selfTenantGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsGet**
> BuiltList<Shipment> shipmentsGet(tenantId, orderId, carrierId, page, driverId, serialNumber, type, status, size)

List all Shipments

List all Shipments

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final String orderId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the order
final String carrierId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the carrier
final int page = page_example; // int | The page number
final String driverId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the driver
final String serialNumber = serialNumber_example; // String | The serialNumber of the shipment. Matches serialNumber that begin with the values
final ShipmentType type = ; // ShipmentType | The type of the shipment.
final ShipmentStatus status = ; // ShipmentStatus | The status of the shipment.
final ShipmentSize size = ; // ShipmentSize | The size of the shipment.

try {
    final response = api.shipmentsGet(tenantId, orderId, carrierId, page, driverId, serialNumber, type, status, size);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->shipmentsGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| The id of the tenant | [optional] 
 **orderId** | **String**| The id of the order | [optional] 
 **carrierId** | **String**| The id of the carrier | [optional] 
 **page** | **int**| The page number | [optional] 
 **driverId** | **String**| The id of the driver | [optional] 
 **serialNumber** | **String**| The serialNumber of the shipment. Matches serialNumber that begin with the values | [optional] 
 **type** | [**ShipmentType**](.md)| The type of the shipment. | [optional] 
 **status** | [**ShipmentStatus**](.md)| The status of the shipment. | [optional] 
 **size** | [**ShipmentSize**](.md)| The size of the shipment. | [optional] 

### Return type

[**BuiltList&lt;Shipment&gt;**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsIdGet**
> Shipment shipmentsIdGet(id, tenantId)

Get shipment details

Get shipment details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the shipment
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.shipmentsIdGet(id, tenantId);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->shipmentsIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the shipment | 
 **tenantId** | **String**| The id of the tenant | [optional] 

### Return type

[**Shipment**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsIdPut**
> Shipment shipmentsIdPut(id, shipment)

Update an existing shipment

Update an existing shipment

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the shipment
final Shipment shipment = ; // Shipment | 

try {
    final response = api.shipmentsIdPut(id, shipment);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->shipmentsIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the shipment | 
 **shipment** | [**Shipment**](Shipment.md)|  | [optional] 

### Return type

[**Shipment**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsPost**
> Shipment shipmentsPost(shipment)

Create a new Shipment

Create a new Shipment

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final Shipment shipment = ; // Shipment | 

try {
    final response = api.shipmentsPost(shipment);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->shipmentsPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **shipment** | [**Shipment**](Shipment.md)|  | [optional] 

### Return type

[**Shipment**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsGet**
> BuiltList<Tenant> tenantsGet(name, page, type)

List all tenants

List all tenants

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String name = name_example; // String | The name of the tenant. Matches names that begin with the values
final int page = page_example; // int | The page number
final TenantType type = ; // TenantType | The type of the tenant.

try {
    final response = api.tenantsGet(name, page, type);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->tenantsGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**| The name of the tenant. Matches names that begin with the values | [optional] 
 **page** | **int**| The page number | [optional] 
 **type** | [**TenantType**](.md)| The type of the tenant. | [optional] 

### Return type

[**BuiltList&lt;Tenant&gt;**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsIdGet**
> Tenant tenantsIdGet(id)

Get tenant details

Get tenant details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.tenantsIdGet(id);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->tenantsIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the tenant | 

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsIdPut**
> Tenant tenantsIdPut(id, tenant)

Update an existing tenant

Update an existing tenant

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final Tenant tenant = ; // Tenant | 

try {
    final response = api.tenantsIdPut(id, tenant);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->tenantsIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the tenant | 
 **tenant** | [**Tenant**](Tenant.md)|  | [optional] 

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsPost**
> Tenant tenantsPost(tenant)

Create a new tenant

Create a new tenant

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final Tenant tenant = ; // Tenant | 

try {
    final response = api.tenantsPost(tenant);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->tenantsPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant** | [**Tenant**](Tenant.md)|  | [optional] 

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsGet**
> BuiltList<Terminal> terminalsGet(tenantId, page, name, type)

List all Terminals

List all Terminals

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final int page = page_example; // int | The page number
final String name = name_example; // String | The name of the terminal. Matches names that begin with the values
final TerminalType type = ; // TerminalType | The type of the terminal.

try {
    final response = api.terminalsGet(tenantId, page, name, type);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->terminalsGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| The id of the tenant | [optional] 
 **page** | **int**| The page number | [optional] 
 **name** | **String**| The name of the terminal. Matches names that begin with the values | [optional] 
 **type** | [**TerminalType**](.md)| The type of the terminal. | [optional] 

### Return type

[**BuiltList&lt;Terminal&gt;**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsIdGet**
> Terminal terminalsIdGet(id, tenantId)

Get terminal details

Get terminal details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the terminal
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.terminalsIdGet(id, tenantId);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->terminalsIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the terminal | 
 **tenantId** | **String**| The id of the tenant | [optional] 

### Return type

[**Terminal**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsIdPut**
> Terminal terminalsIdPut(id, terminal)

Update an existing terminal

Update an existing terminal

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the terminal
final Terminal terminal = ; // Terminal | 

try {
    final response = api.terminalsIdPut(id, terminal);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->terminalsIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the terminal | 
 **terminal** | [**Terminal**](Terminal.md)|  | [optional] 

### Return type

[**Terminal**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsPost**
> Terminal terminalsPost(terminal)

Create a new Terminal

Create a new Terminal

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final Terminal terminal = ; // Terminal | 

try {
    final response = api.terminalsPost(terminal);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->terminalsPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **terminal** | [**Terminal**](Terminal.md)|  | [optional] 

### Return type

[**Terminal**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersGet**
> BuiltList<User> usersGet(tenantId, page, name, role)

List all users

List all users

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
final int page = page_example; // int | The page number
final String name = name_example; // String | The name of the customer. Matches names that begin with the values
final UserRole role = ; // UserRole | The role of the user

try {
    final response = api.usersGet(tenantId, page, name, role);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->usersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | **String**| The id of the tenant | [optional] 
 **page** | **int**| The page number | [optional] 
 **name** | **String**| The name of the customer. Matches names that begin with the values | [optional] 
 **role** | [**UserRole**](.md)| The role of the user | [optional] 

### Return type

[**BuiltList&lt;User&gt;**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersIdDelete**
> usersIdDelete(id)

Delete the user

Delete the user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the user

try {
    api.usersIdDelete(id);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->usersIdDelete: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the user | 

### Return type

void (empty response body)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersIdGet**
> User usersIdGet(id, tenantId)

Get user details

Get user details

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the user
final String tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try {
    final response = api.usersIdGet(id, tenantId);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->usersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the user | 
 **tenantId** | **String**| The id of the tenant | [optional] 

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersIdPut**
> User usersIdPut(id, user)

Update an existing user

Update an existing user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final String id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the user
final User user = ; // User | 

try {
    final response = api.usersIdPut(id, user);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->usersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| The id of the user | 
 **user** | [**User**](User.md)|  | [optional] 

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersPost**
> User usersPost(user)

Create a new user

Create a new user

### Example
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

final api = TroberSdk().getDefaultApi();
final User user = ; // User | 

try {
    final response = api.usersPost(user);
    print(response);
} catch on DioError (e) {
    print('Exception when calling DefaultApi->usersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user** | [**User**](User.md)|  | [optional] 

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

