//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

import 'package:trober_sdk/src/model/carrier.dart';
import 'package:trober_sdk/src/model/customer.dart';
import 'package:built_collection/built_collection.dart';
import 'package:trober_sdk/src/model/shipment.dart';
import 'package:trober_sdk/src/model/shipment_type.dart';
import 'package:trober_sdk/src/model/order_status.dart';
import 'package:trober_sdk/src/model/terminal.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'order.g.dart';

/// A customer order that is being processed
///
/// Properties:
/// * [id] 
/// * [createdAt] 
/// * [updatedAt] 
/// * [createdBy] 
/// * [tenantId] 
/// * [customerId] 
/// * [carrierId] 
/// * [terminalId] 
/// * [serialNumber] 
/// * [eta] 
/// * [soNumber] 
/// * [shipline] 
/// * [pickupCharges] 
/// * [pickupCost] 
/// * [dropoffCharges] 
/// * [dropoffCost] 
/// * [rld] 
/// * [erd] 
/// * [docco] 
/// * [lfd] 
/// * [containerStatus] 
/// * [shipmentCount] 
/// * [status] 
/// * [type] 
/// * [customer] 
/// * [carrier] 
/// * [terminal] 
/// * [shipments] - A list of Shipments
abstract class Order implements Built<Order, OrderBuilder> {
    @BuiltValueField(wireName: r'id')
    String get id;

    @BuiltValueField(wireName: r'created_at')
    DateTime get createdAt;

    @BuiltValueField(wireName: r'updated_at')
    DateTime get updatedAt;

    @BuiltValueField(wireName: r'created_by')
    String? get createdBy;

    @BuiltValueField(wireName: r'tenant_id')
    String get tenantId;

    @BuiltValueField(wireName: r'customer_id')
    String? get customerId;

    @BuiltValueField(wireName: r'carrier_id')
    String? get carrierId;

    @BuiltValueField(wireName: r'terminal_id')
    String? get terminalId;

    @BuiltValueField(wireName: r'serial_number')
    String get serialNumber;

    @BuiltValueField(wireName: r'eta')
    DateTime? get eta;

    @BuiltValueField(wireName: r'so_number')
    String? get soNumber;

    @BuiltValueField(wireName: r'shipline')
    String? get shipline;

    @BuiltValueField(wireName: r'pickup_charges')
    int? get pickupCharges;

    @BuiltValueField(wireName: r'pickup_cost')
    int? get pickupCost;

    @BuiltValueField(wireName: r'dropoff_charges')
    int? get dropoffCharges;

    @BuiltValueField(wireName: r'dropoff_cost')
    int? get dropoffCost;

    @BuiltValueField(wireName: r'rld')
    String? get rld;

    @BuiltValueField(wireName: r'erd')
    DateTime? get erd;

    @BuiltValueField(wireName: r'docco')
    DateTime? get docco;

    @BuiltValueField(wireName: r'lfd')
    DateTime? get lfd;

    @BuiltValueField(wireName: r'container_status')
    String? get containerStatus;

    @BuiltValueField(wireName: r'shipment_count')
    int? get shipmentCount;

    @BuiltValueField(wireName: r'status')
    OrderStatus get status;
    // enum statusEnum {  Open,  Accepted,  Cancelled,  InProgress,  Delivered,  Invoiced,  PaymentReceived,  };

    @BuiltValueField(wireName: r'type')
    ShipmentType? get type;
    // enum typeEnum {  Inbound,  Outbound,  };

    @BuiltValueField(wireName: r'customer')
    Customer? get customer;

    @BuiltValueField(wireName: r'carrier')
    Carrier? get carrier;

    @BuiltValueField(wireName: r'terminal')
    Terminal? get terminal;

    /// A list of Shipments
    @BuiltValueField(wireName: r'Shipments')
    BuiltList<Shipment>? get shipments;

    Order._();

    @BuiltValueHook(initializeBuilder: true)
    static void _defaults(OrderBuilder b) => b;

    factory Order([void updates(OrderBuilder b)]) = _$Order;

    @BuiltValueSerializer(custom: true)
    static Serializer<Order> get serializer => _$OrderSerializer();
}

class _$OrderSerializer implements StructuredSerializer<Order> {
    @override
    final Iterable<Type> types = const [Order, _$Order];

    @override
    final String wireName = r'Order';

    @override
    Iterable<Object?> serialize(Serializers serializers, Order object,
        {FullType specifiedType = FullType.unspecified}) {
        final result = <Object?>[];
        result
            ..add(r'id')
            ..add(serializers.serialize(object.id,
                specifiedType: const FullType(String)));
        result
            ..add(r'created_at')
            ..add(serializers.serialize(object.createdAt,
                specifiedType: const FullType(DateTime)));
        result
            ..add(r'updated_at')
            ..add(serializers.serialize(object.updatedAt,
                specifiedType: const FullType(DateTime)));
        if (object.createdBy != null) {
            result
                ..add(r'created_by')
                ..add(serializers.serialize(object.createdBy,
                    specifiedType: const FullType(String)));
        }
        result
            ..add(r'tenant_id')
            ..add(serializers.serialize(object.tenantId,
                specifiedType: const FullType(String)));
        if (object.customerId != null) {
            result
                ..add(r'customer_id')
                ..add(serializers.serialize(object.customerId,
                    specifiedType: const FullType(String)));
        }
        if (object.carrierId != null) {
            result
                ..add(r'carrier_id')
                ..add(serializers.serialize(object.carrierId,
                    specifiedType: const FullType(String)));
        }
        if (object.terminalId != null) {
            result
                ..add(r'terminal_id')
                ..add(serializers.serialize(object.terminalId,
                    specifiedType: const FullType(String)));
        }
        result
            ..add(r'serial_number')
            ..add(serializers.serialize(object.serialNumber,
                specifiedType: const FullType(String)));
        if (object.eta != null) {
            result
                ..add(r'eta')
                ..add(serializers.serialize(object.eta,
                    specifiedType: const FullType(DateTime)));
        }
        if (object.soNumber != null) {
            result
                ..add(r'so_number')
                ..add(serializers.serialize(object.soNumber,
                    specifiedType: const FullType(String)));
        }
        if (object.shipline != null) {
            result
                ..add(r'shipline')
                ..add(serializers.serialize(object.shipline,
                    specifiedType: const FullType(String)));
        }
        if (object.pickupCharges != null) {
            result
                ..add(r'pickup_charges')
                ..add(serializers.serialize(object.pickupCharges,
                    specifiedType: const FullType(int)));
        }
        if (object.pickupCost != null) {
            result
                ..add(r'pickup_cost')
                ..add(serializers.serialize(object.pickupCost,
                    specifiedType: const FullType(int)));
        }
        if (object.dropoffCharges != null) {
            result
                ..add(r'dropoff_charges')
                ..add(serializers.serialize(object.dropoffCharges,
                    specifiedType: const FullType(int)));
        }
        if (object.dropoffCost != null) {
            result
                ..add(r'dropoff_cost')
                ..add(serializers.serialize(object.dropoffCost,
                    specifiedType: const FullType(int)));
        }
        if (object.rld != null) {
            result
                ..add(r'rld')
                ..add(serializers.serialize(object.rld,
                    specifiedType: const FullType(String)));
        }
        if (object.erd != null) {
            result
                ..add(r'erd')
                ..add(serializers.serialize(object.erd,
                    specifiedType: const FullType(DateTime)));
        }
        if (object.docco != null) {
            result
                ..add(r'docco')
                ..add(serializers.serialize(object.docco,
                    specifiedType: const FullType(DateTime)));
        }
        if (object.lfd != null) {
            result
                ..add(r'lfd')
                ..add(serializers.serialize(object.lfd,
                    specifiedType: const FullType(DateTime)));
        }
        if (object.containerStatus != null) {
            result
                ..add(r'container_status')
                ..add(serializers.serialize(object.containerStatus,
                    specifiedType: const FullType(String)));
        }
        if (object.shipmentCount != null) {
            result
                ..add(r'shipment_count')
                ..add(serializers.serialize(object.shipmentCount,
                    specifiedType: const FullType(int)));
        }
        result
            ..add(r'status')
            ..add(serializers.serialize(object.status,
                specifiedType: const FullType(OrderStatus)));
        if (object.type != null) {
            result
                ..add(r'type')
                ..add(serializers.serialize(object.type,
                    specifiedType: const FullType(ShipmentType)));
        }
        if (object.customer != null) {
            result
                ..add(r'customer')
                ..add(serializers.serialize(object.customer,
                    specifiedType: const FullType(Customer)));
        }
        if (object.carrier != null) {
            result
                ..add(r'carrier')
                ..add(serializers.serialize(object.carrier,
                    specifiedType: const FullType(Carrier)));
        }
        if (object.terminal != null) {
            result
                ..add(r'terminal')
                ..add(serializers.serialize(object.terminal,
                    specifiedType: const FullType(Terminal)));
        }
        if (object.shipments != null) {
            result
                ..add(r'Shipments')
                ..add(serializers.serialize(object.shipments,
                    specifiedType: const FullType(BuiltList, [FullType(Shipment)])));
        }
        return result;
    }

    @override
    Order deserialize(Serializers serializers, Iterable<Object?> serialized,
        {FullType specifiedType = FullType.unspecified}) {
        final result = OrderBuilder();

        final iterator = serialized.iterator;
        while (iterator.moveNext()) {
            final key = iterator.current as String;
            iterator.moveNext();
            final Object? value = iterator.current;
            
            switch (key) {
                case r'id':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.id = valueDes;
                    break;
                case r'created_at':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(DateTime)) as DateTime;
                    result.createdAt = valueDes;
                    break;
                case r'updated_at':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(DateTime)) as DateTime;
                    result.updatedAt = valueDes;
                    break;
                case r'created_by':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.createdBy = valueDes;
                    break;
                case r'tenant_id':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.tenantId = valueDes;
                    break;
                case r'customer_id':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.customerId = valueDes;
                    break;
                case r'carrier_id':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.carrierId = valueDes;
                    break;
                case r'terminal_id':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.terminalId = valueDes;
                    break;
                case r'serial_number':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.serialNumber = valueDes;
                    break;
                case r'eta':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(DateTime)) as DateTime;
                    result.eta = valueDes;
                    break;
                case r'so_number':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.soNumber = valueDes;
                    break;
                case r'shipline':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.shipline = valueDes;
                    break;
                case r'pickup_charges':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(int)) as int;
                    result.pickupCharges = valueDes;
                    break;
                case r'pickup_cost':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(int)) as int;
                    result.pickupCost = valueDes;
                    break;
                case r'dropoff_charges':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(int)) as int;
                    result.dropoffCharges = valueDes;
                    break;
                case r'dropoff_cost':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(int)) as int;
                    result.dropoffCost = valueDes;
                    break;
                case r'rld':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.rld = valueDes;
                    break;
                case r'erd':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(DateTime)) as DateTime;
                    result.erd = valueDes;
                    break;
                case r'docco':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(DateTime)) as DateTime;
                    result.docco = valueDes;
                    break;
                case r'lfd':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(DateTime)) as DateTime;
                    result.lfd = valueDes;
                    break;
                case r'container_status':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(String)) as String;
                    result.containerStatus = valueDes;
                    break;
                case r'shipment_count':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(int)) as int;
                    result.shipmentCount = valueDes;
                    break;
                case r'status':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(OrderStatus)) as OrderStatus;
                    result.status = valueDes;
                    break;
                case r'type':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(ShipmentType)) as ShipmentType;
                    result.type = valueDes;
                    break;
                case r'customer':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(Customer)) as Customer;
                    result.customer.replace(valueDes);
                    break;
                case r'carrier':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(Carrier)) as Carrier;
                    result.carrier.replace(valueDes);
                    break;
                case r'terminal':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(Terminal)) as Terminal;
                    result.terminal.replace(valueDes);
                    break;
                case r'Shipments':
                    final valueDes = serializers.deserialize(value,
                        specifiedType: const FullType(BuiltList, [FullType(Shipment)])) as BuiltList<Shipment>;
                    result.shipments.replace(valueDes);
                    break;
            }
        }
        return result.build();
    }
}

